#ifndef CREFL171_MERSI_H
#define CREFL171_MERSI_H 1

#include "crefl.1.7.1_common.h"

#define	MERSI_NUM1KMCOLPERSCAN 2048
#define	MERSI_NUM1KMROWPERSCAN 10

/*
 * Parameters:
 * process - An char array (Nbands), where each element indicates if that specific band number's data will 
 *           be processed or not.
 */
void mersi_process_options (int main_argc, char *main_argv [], crefl_in_options_st *options_val_st, char **filename, unsigned char *process);
void mersi_init_data (crefl_in_options_st *options_val_st, SDS *sds_st_arr, unsigned char *process);
void mersi_finalize_data (crefl_in_options_st *options_val_st, SDS *sds_st_arr);
void mersi_usage (void);

/*
Parse MERSI L1B or coarse-resolution input file names to identify
expected spatial resolution of the MERSI swath present in file.
*/
int mersi_input_file_type (char *filename);

int mersi_clause_solz_neg_l1bdata (SDS *solz_st, SDS *l1bdata_st, SDS *outsds_st, int crsidx, int idx);

int mersi_test_solz_gt_maxsolz (SDS *solz_st, int idx, float maxsolz);
int mersi_test_solz_ne_fillvalue (SDS *solz_st, int idx);
int mersi_test_bad_val (SDS *solz_st, int crsidx11, int crsidx12, int crsidx21, int crsidx22);

void mersi_set_solz_to_fillvalue (SDS *solz_st, int idx);

float mersi_calculate_refl (SDS *l1bdata_st, int idx, float mus0);
float mersi_calculate_mus (SDS *solz_st, int idx);
float mersi_calculate_phi (SDS *sola_st, SDS *sena_st, int idx);
float mersi_calculate_muv (SDS *senz_st, int idx);

int mersi_read_scan (int iscan, SDS sds_st_arr[Nitems]);

#endif /* CREFL171_MERSI_H */

