#ifndef CREFL171_VIIRS_H
#define CREFL171_VIIRS_H 1

#include "crefl.1.7.1_common.h"

#define	VIIRS_NUM750MCOLPERSCAN 3200
#define	VIIRS_NUM750MROWPERSCAN 16

/*
 * Parameters:
 * process - An char array (Nbands), where each element indicates if that specific band number's data will 
 *           be processed or not.
 */
void viirs_process_options (int main_argc, char *main_argv [], crefl_in_options_st *options_val_st, char **filename, unsigned char *process);
void viirs_init_data (crefl_in_options_st *options_val_st, SDS *sds_st_arr, unsigned char *process);
void viirs_finalize_data (crefl_in_options_st *options_val_st, SDS *sds_st_arr);
void viirs_usage(void);
int viirs_input_file_type (char *filename);

int viirs_clause_solz_neg_l1bdata (SDS *solz_st, SDS *l1bdata_st, SDS *outsds_st, int crsidx, int idx);

int viirs_test_solz_gt_maxsolz (SDS *solz_st, int idx, float maxsolz);
int viirs_test_solz_ne_fillvalue (SDS *solz_st, int idx);
int viirs_test_bad_val (SDS *solz_st, int crsidx11, int crsidx12, int crsidx21, int crsidx22);

void viirs_set_solz_to_fillvalue (SDS *solz_st, int idx);

float viirs_calculate_refl (SDS *l1bdata_st, int idx);
float viirs_calculate_mus (SDS *solz_st, int idx);
float viirs_calculate_phi (SDS *sola_st, SDS *sena_st, int idx);
float viirs_calculate_muv (SDS *senz_st, int idx);

int viirs_read_scan (int iscan, SDS sds_st_arr [Nitems]);

#endif /* CREFL171_VIIRS_H */

